'use strict';

angular.module('adf.widget.electre.symod', ['adf.provider', 'ng-fusioncharts'])
    .constant('SYMOD_TEMPLATE_PATH', "/resource/rsc/electre/widgets/symod/templates")
    .value("fusionChartTypes", {
        defaultType : 'mscolumn2d',
        types : [
            "mscolumn2d",
            "mscolumn3d",
            "msline",
            "msbar2d",
            "msbar3d",
            "msarea",
            "marimekko",
            "zoomline",
            "zoomlinedy"
        ]
    })
    .config(
        [
            "dashboardProvider",
            function (dashboardProvider) {
                dashboardProvider.widget('symodChart', {
                    title        : 'Symod chart Widget',
                    display      : 'Symod chart widget for dashboard electre',
                    description  : '',
                    controller   : 'symodChartCtrl',
                    controllerAs : 'symodChart',
                    templateUrl  : "{widgetsPath}/symod/templates/view.html",
                    reload       : true,
                    resolve : {
                        isEdit: function () {return false;}
                    },
                    edit         : {
                        controller  : "symodChartCtrl",
                        immediate   : true,
                        templateUrl : "{widgetsPath}/symod/templates/edit.html",
                        resolve : {
                            isEdit : function () { return true;}
                        }
                    }
                });
            }
        ]
    )
    .controller("symodChartCtrl", [
        "$scope", "config", "isEdit", "fusionChartTypes", "domService",
        function ($scope, config, isEdit, fusionChartTypes, domService) {
            $scope.more_settings = $scope.more_settings || false;
            $scope.fusionChartConfig = {};
            $scope.fusionChartConfig.width            = config.width            = config.width            || 100;
            $scope.fusionChartConfig.widthPercentage  = config.widthPercentage  = config.widthPercentage  || true;
            $scope.fusionChartConfig.height           = config.height           = config.height           || 345;
            $scope.fusionChartConfig.heightPercentage = config.heightPercentage = config.heightPercentage || false;
            $scope.fusionChartConfig.type             = config.type             = config.type             || fusionChartTypes.defaultType;

            if (isEdit) {
                var type = document.getElementById("type");
                for (var t = 0 ; t < fusionChartTypes.types.length ; t++) {
                    var option = domService.createElement("option").setAttribute('value', fusionChartTypes.types[t]).getDom();
                    option.innerHTML = option.getAttribute('value');
                    type.appendChild(option);
                }
            } else {
                $scope.url = config.url = config.url || true;
                if ($scope.url) {
                    $scope.valid = true;
                }
            }
        }
    ]);